Controllers/AuthenticationController.cs
using Backend_Task2.Forum;
using Backend_Task2.Forum.Models;
using Backend_Task3.Services;
using Backend_Task2.ViewModels;
using Microsoft.AspNetCore.Identity;
using Microsoft.AspNetCore.Mvc;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Authorization;

namespace Backend_Task3.Controllers
{
    [AllowAnonymous]
    public class AuthenticationController : Controller
    {
        private readonly ApplicationDbContext _context;
        private readonly IUserService _service;
        private readonly UserManager<AppUserModel> _userManager;
        private readonly SignInManager<AppUserModel> _signInManager;

        public AuthenticationController(SignInManager<AppUserModel> signInManager, UserManager<AppUserModel> userManager, IUserService service, ApplicationDbContext context)
        {
            _signInManager = signInManager;
            _userManager = userManager;
            _service = service;
            _context = context;
        }

        public ActionResult Register()
        {
            return View();
        }

        [HttpPost]
        public async Task<ActionResult> Register(UserRegisterViewModel model)
        {
            try
            {
                if (!ModelState.IsValid)
                {
                    return View(model);
                }

                await _service.RegisterUserAsync(model);

                TempData["SuccessMessage"] = "Аккаунт успешно создан.";

                return RedirectToAction("Index", "Forum");
            }
            catch (ArgumentException)
            {
                ViewBag.ErrorMessage = "Пароли не совпадают.";
                return View(model);
            }
            catch (Exception e)
            {
                if (e.Message == "A user with such name already exists.")
                {
                    ViewBag.ErrorMessage = "Пользователь с таким именем уже существует.";
                    return View(model);
                }
                
                ViewBag.ErrorMessage = "Что-то пошло не так, попробуйте ещё раз.";
                return View(model);
            }

        }

        public ActionResult LogIn()
        {
            return View();
        }

        [HttpPost]
        public async Task<ActionResult> LogIn(UserLogInViewModel model)
        {
            try
            {
                if (!ModelState.IsValid)
                {
                    return View(model);
                }

                var signInResult = await _signInManager.PasswordSignInAsync(model.UserName, model.Password, false, false);
                if (signInResult.Succeeded)
                {
                    return RedirectToAction("Index", "Home");
                }

                return View(model);
            }
            catch
            {
                ViewBag.ErrorMessage = "Что-то пошло не так, попробуйте ещё раз.";
                return View(model);
            }
        }

        [HttpPost]
        public async Task<ActionResult> Logout()
        {
            try
            {
                await _signInManager.SignOutAsync();
                return RedirectToAction("Index", "Home");
            }
            catch
            {
                return RedirectToAction("Index", "Home");
            }
        }
    }
}

Views/Authentication/LogIn.cshtml
@model UserLogInViewModel

<form asp-action="LogIn" asp-controller="Authentication" method="post">
    <label asp-for="UserName"></label>
    <input asp-for="UserName" type="text" class="form-control" />
    <span asp-validation-for="UserName" class="text-danger"></span>

    <label asp-for="Password"></label>
    <input asp-for="Password" type="password" class="form-control" />
    <span asp-validation-for="Password" class="text-danger"></span>

    <input type="submit" value="Войти" class="btn btn-primary" />
</form>

Views/Authentication/Register.cshtml
@model Backend_Task2.ViewModels.UserRegisterViewModel

@{
    ViewData["Title"] = "Register";
}

<h1>Register</h1>

<h4>UserRegisterViewModel</h4>
<hr />
<div class="row">
    <div class="col-md-4">
        <form asp-action="Register">
            <div asp-validation-summary="ModelOnly" class="text-danger"></div>
            <div class="form-group">
                <label asp-for="UserName" class="control-label"></label>
                <input asp-for="UserName" class="form-control" />
                <span asp-validation-for="UserName" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Password" class="control-label"></label>
                <input asp-for="Password" type="password" class="form-control" />
                <span asp-validation-for="Password" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="ConfirmPassword" class="control-label"></label>
                <input asp-for="ConfirmPassword" type="password" class="form-control" />
                <span asp-validation-for="ConfirmPassword" class="text-danger"></span>
            </div>
            <div class="form-group">
                <input type="submit" value="Create" class="btn btn-primary" />
            </div>
        </form>
    </div>
</div>

<div>
    <a asp-action="Index">Back to List</a>
</div>

@section Scripts {
    @{await Html.RenderPartialAsync("_ValidationScriptsPartial");}
}